diff -u -r linux.clean/drivers/scsi/sr.c linux.new2/drivers/scsi/sr.c
--- linux.clean/drivers/scsi/sr.c	Tue May 11 17:37:40 1999
+++ linux.new2/drivers/scsi/sr.c	Wed Jul 28 19:47:14 1999
@@ -1,17 +1,17 @@
 /*
  *  sr.c Copyright (C) 1992 David Giller
- *	     Copyright (C) 1993, 1994, 1995 Eric Youngdale
+ *	     Copyright (C) 1993, 1994, 1995, 1999 Eric Youngdale
  *
  *  adapted from:
  *	sd.c Copyright (C) 1992 Drew Eckhardt
  *	Linux scsi disk driver by
  *		Drew Eckhardt <drew@colorado.edu>
  *
- *      Modified by Eric Youngdale ericy@cais.com to
+ *      Modified by Eric Youngdale ericy@andante.org to
  *      add scatter-gather, multiple outstanding request, and other
  *      enhancements.
  *
- *	    Modified by Eric Youngdale eric@aib.com to support loadable
+ *	    Modified by Eric Youngdale eric@andante.org to support loadable
  *	    low-level scsi drivers.
  *
  *	 Modified by Thomas Quinot thomas@melchior.cuivre.fdn.fr to
@@ -54,10 +54,26 @@
 static int sr_detect(Scsi_Device *);
 static void sr_detach(Scsi_Device *);
 
-struct Scsi_Device_Template sr_template = {NULL, "cdrom", "sr", NULL, TYPE_ROM,
-                                           SCSI_CDROM_MAJOR, 0, 0, 0, 1,
-                                           sr_detect, sr_init,
-                                           sr_finish, sr_attach, sr_detach};
+#ifdef CONFIG_SCSI_NEW_QUEUES
+static int sr_init_command(Scsi_Cmnd *);
+#endif
+
+struct Scsi_Device_Template sr_template = 
+{
+    name:       "cdrom", 
+    tag:        "sr", 
+    scsi_type:  TYPE_ROM,
+    major:      SCSI_CDROM_MAJOR, 
+    blk:        1,
+    detect:     sr_detect, 
+    init:       sr_init,
+    finish:     sr_finish, 
+    attach:     sr_attach, 
+    detach:     sr_detach,
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    init_command: sr_init_command
+#endif
+};
 
 Scsi_CD * scsi_CDs = NULL;
 static int * sr_sizes = NULL;
@@ -73,8 +89,13 @@
 
 static void sr_release(struct cdrom_device_info *cdi)
 {
+#ifdef CONFIG_SCSI_NEW_QUEUES
+	if (scsi_CDs[MINOR(cdi->dev)].device->sector_size > 2048)
+		sr_set_blocklength(MINOR(cdi->dev),2048);
+#else
 	if (scsi_CDs[MINOR(cdi->dev)].sector_size > 2048)
 		sr_set_blocklength(MINOR(cdi->dev),2048);
+#endif
 	sync_dev(cdi->dev);
 	scsi_CDs[MINOR(cdi->dev)].device->access_count--;
 	if (scsi_CDs[MINOR(cdi->dev)].device->host->hostt->module)
@@ -153,7 +174,11 @@
                   */
                 scsi_CDs[MINOR(cdi->dev)].needs_sector_size = 1;
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+                scsi_CDs[MINOR(cdi->dev)].device->sector_size = 2048;
+#else
                 scsi_CDs[MINOR(cdi->dev)].sector_size = 2048;
+#endif
         }
 	return retval;
 }
@@ -178,6 +203,46 @@
       Since this is a relatively rare error condition, no care is taken to
       avoid unnecessary additional work such as memcpy's that could be avoided.
     */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+
+    if (driver_byte(result) != 0 &&		    /* An error occurred */
+        SCpnt->sense_buffer[0] == 0xF0 &&	    /* Sense data is valid */
+        (SCpnt->sense_buffer[2] == MEDIUM_ERROR ||
+         SCpnt->sense_buffer[2] == VOLUME_OVERFLOW ||
+         SCpnt->sense_buffer[2] == ILLEGAL_REQUEST))
+    {
+        long error_sector = (SCpnt->sense_buffer[3] << 24) |
+            (SCpnt->sense_buffer[4] << 16) |
+            (SCpnt->sense_buffer[5] << 8) |
+            SCpnt->sense_buffer[6];
+        int device_nr = DEVICE_NR(SCpnt->request.rq_dev);
+        if (SCpnt->request.bh != NULL)
+            block_sectors = SCpnt->request.bh->b_size >> 9;
+        if (block_sectors < 4) block_sectors = 4;
+        if (scsi_CDs[device_nr].device->sector_size == 2048)
+            error_sector <<= 2;
+        error_sector &= ~ (block_sectors - 1);
+        good_sectors = error_sector - SCpnt->request.sector;
+        if (good_sectors < 0 || good_sectors >= this_count)
+            good_sectors = 0;
+        /*
+         * The SCSI specification allows for the value returned by READ
+         * CAPACITY to be up to 75 2K sectors past the last readable
+         * block.  Therefore, if we hit a medium error within the last
+         * 75 2K sectors, we decrease the saved size value.
+         */
+        if ((error_sector >> 1) < sr_sizes[device_nr] &&
+            scsi_CDs[device_nr].capacity - error_sector < 4*75)
+            sr_sizes[device_nr] = error_sector >> 1;
+    }
+
+    /*
+     * This calls the generic completion function, now that we know
+     * how many actual sectors finished, and how many sectors we need
+     * to say have failed.
+     */
+    scsi_io_completion(SCpnt, good_sectors, block_sectors);
+#else
 
 	if (driver_byte(result) != 0 &&		    /* An error occurred */
 	    SCpnt->sense_buffer[0] == 0xF0 &&	    /* Sense data is valid */
@@ -376,7 +441,183 @@
 	SCpnt = end_scsi_request(SCpnt, 0, SCpnt->request.current_nr_sectors);
 	requeue_sr_request(SCpnt);
     }
+#endif
+}
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+
+static request_queue_t * sr_find_queue(kdev_t dev)
+{
+    if(   MINOR(dev) >= sr_template.dev_max 
+       || !scsi_CDs[MINOR(dev)].device)
+	return NULL;   /* No such device */
+    return &scsi_CDs[MINOR(dev)].device->request_queue;
+}
+
+static int sr_init_command(Scsi_Cmnd * SCpnt)
+{
+    int dev, devm, block, this_count;
+    char nbuff[6];
+
+    devm =  MINOR(SCpnt->request.rq_dev);
+    dev = DEVICE_NR(SCpnt->request.rq_dev);
+
+    block = SCpnt->request.sector;
+    this_count = SCpnt->request_bufflen >> 9;
+
+    if( !SCpnt->request.bh )
+    {
+        /*
+         * Umm, yeah, right.   Swapping to a cdrom.  Nice try.
+         */
+	SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+        return 0;
+    }
+
+    SCSI_LOG_HLQUEUE(1,printk("Doing sd request, dev = %d, block = %d\n", devm, block));
+
+    if ( dev >= sr_template.nr_dev || 
+	!scsi_CDs[dev].device ||
+	!scsi_CDs[dev].device->online)
+    {
+        SCSI_LOG_HLQUEUE(2,printk("Finishing %ld sectors\n", SCpnt->request.nr_sectors));
+	SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+        SCSI_LOG_HLQUEUE(2,printk("Retry with 0x%p\n", SCpnt));
+        return 0;
+    }
+
+    if (scsi_CDs[dev].device->changed) 
+    {
+	/*
+	 * quietly refuse to do anything to a changed disc until the changed
+	 * bit has been reset
+	 */
+	/* printk("SCSI disk has been changed. Prohibiting further I/O.\n"); */
+	SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+        return 0;
+    }
+
+    /*
+     * we do lazy blocksize switching (when reading XA sectors,
+     * see CDROMREADMODE2 ioctl) 
+     */
+    if( scsi_CDs[dev].device->sector_size > 2048 ) 
+    {
+        if (!in_interrupt())
+            sr_set_blocklength(DEVICE_NR(CURRENT->rq_dev),2048);
+        else
+            printk("sr: can't switch blocksize: in interrupt\n");
+    }
+
+    if( SCpnt->request.cmd == WRITE )
+    {
+	SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+        return 0;
+    }
+
+    if (scsi_CDs[dev].device->sector_size == 1024)
+    {
+	if((block & 1) || (SCpnt->request.nr_sectors & 1)) 
+        {
+	    printk("sd.c:Bad block number requested");
+	    SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+	    return 0;
+	}
+        else
+        {
+            block = block >> 1;
+            this_count = this_count >> 1;
+        }
+    }
+
+     if (scsi_CDs[dev].device->sector_size == 2048)
+     {
+         if((block & 3) || (SCpnt->request.nr_sectors & 3)) 
+         {
+             printk("sd.c:Bad block number requested");
+             SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+             return 0;
+         }
+         else
+         {
+             block = block >> 2;
+             this_count = this_count >> 2;
+         }
+     }
+    switch (SCpnt->request.cmd)
+    {
+    case WRITE :
+	if (!scsi_CDs[dev].device->writeable)
+	{
+	    SCpnt = scsi_end_request(SCpnt, 0, SCpnt->request.nr_sectors);
+            return 0;
+	}
+	SCpnt->cmnd[0] = WRITE_6;
+	break;
+    case READ :
+	SCpnt->cmnd[0] = READ_6;
+	break;
+    default :
+	panic ("Unknown sd command %d\n", SCpnt->request.cmd);
+    }
+
+    SCSI_LOG_HLQUEUE(2,printk("%s : %s %d/%ld 512 byte blocks.\n",
+                              nbuff,
+                              (SCpnt->request.cmd == WRITE) ? "writing" : "reading",
+                              this_count, SCpnt->request.nr_sectors));
+
+    SCpnt->cmnd[1] = (SCpnt->lun << 5) & 0xe0;  
+   
+    if (((this_count > 0xff) ||  (block > 0x1fffff)) && SCpnt->device->ten)
+    {
+	if (this_count > 0xffff)
+	    this_count = 0xffff;
+
+	SCpnt->cmnd[0] += READ_10 - READ_6 ;
+	SCpnt->cmnd[2] = (unsigned char) (block >> 24) & 0xff;
+	SCpnt->cmnd[3] = (unsigned char) (block >> 16) & 0xff;
+	SCpnt->cmnd[4] = (unsigned char) (block >> 8) & 0xff;
+	SCpnt->cmnd[5] = (unsigned char) block & 0xff;
+	SCpnt->cmnd[6] = SCpnt->cmnd[9] = 0;
+	SCpnt->cmnd[7] = (unsigned char) (this_count >> 8) & 0xff;
+	SCpnt->cmnd[8] = (unsigned char) this_count & 0xff;
+    }
+    else
+    {
+	if (this_count > 0xff)
+	    this_count = 0xff;
+
+	SCpnt->cmnd[1] |= (unsigned char) ((block >> 16) & 0x1f);
+	SCpnt->cmnd[2] = (unsigned char) ((block >> 8) & 0xff);
+	SCpnt->cmnd[3] = (unsigned char) block & 0xff;
+	SCpnt->cmnd[4] = (unsigned char) this_count;
+	SCpnt->cmnd[5] = 0;
+    }
+
+    /*
+     * We shouldn't disconnect in the middle of a sector, so with a dumb
+     * host adapter, it's safe to assume that we can at least transfer
+     * this many bytes between each connect / disconnect.
+     */
+    SCpnt->transfersize = scsi_CDs[dev].device->sector_size;
+    SCpnt->underflow = this_count << 9;
+    
+    SCpnt->allowed = MAX_RETRIES;
+    SCpnt->timeout_per_command = SR_TIMEOUT;
+
+    /*
+     * This is the completion routine we use.  This is matched in terms
+     * of capability to this function.
+     */
+    SCpnt->done = rw_intr;
+
+    /*
+     * This indicates that the command is ready from our end to be
+     * queued.
+     */
+    return 1;
 }
+#endif
 
 static int sr_open(struct cdrom_device_info *cdi, int purpose)
 {
@@ -419,8 +660,8 @@
  * Its function in life is to take block device requests, and
  * translate them to SCSI commands.
  */
-
-static void do_sr_request (void)
+#ifndef CONFIG_SCSI_NEW_QUEUES
+static void do_sr_request (request_queue_t * q)
 {
     Scsi_Cmnd * SCpnt = NULL;
     struct request * req = NULL;
@@ -428,7 +669,7 @@
     int flag = 0;
 
     while (1==1){
-	if (CURRENT != NULL && CURRENT->rq_status == RQ_INACTIVE) {
+	if (CURRENT != NULL && q->plugged) {
 	    return;
 	};
 
@@ -506,6 +747,9 @@
 		req1 = req;
 		req = req->next;
 	    }
+            /*
+             * WTF???   Why are we interested in requests that are inactive?
+             */
 	    if (SCpnt && req->rq_status == RQ_INACTIVE) {
 		if (req == CURRENT)
 		    CURRENT = CURRENT->next;
@@ -534,7 +778,7 @@
 
  repeat:
 	if(!SCpnt || SCpnt->request.rq_status == RQ_INACTIVE) {
-		do_sr_request();
+		do_sr_request(NULL);
 		return;
 	}
 
@@ -822,6 +1066,7 @@
 		 realcount * scsi_CDs[dev].sector_size,
 		 rw_intr, SR_TIMEOUT, MAX_RETRIES);
 }
+#endif
 
 static int sr_detect(Scsi_Device * SDp){
 
@@ -851,7 +1096,10 @@
 
     if(i >= sr_template.dev_max) panic ("scsi_devices corrupt (sr)");
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     SDp->scsi_request_fn = do_sr_request;
+#endif
+
     scsi_CDs[i].device = SDp;
 
     sr_template.nr_dev++;
@@ -873,15 +1121,24 @@
     }
 }
 
-void get_sectorsize(int i){
+void get_sectorsize(int i)
+{
     unsigned char cmd[10];
     unsigned char *buffer;
     int the_result, retries;
+    int sector_size;
     Scsi_Cmnd * SCpnt;
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned long flags;
+#endif
 
     buffer = (unsigned char *) scsi_malloc(512);
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    SCpnt = scsi_allocate_device(scsi_CDs[i].device, 1);
+#else
     SCpnt = scsi_allocate_device(NULL, scsi_CDs[i].device, 1);
+#endif
 
     retries = 3;
     do {
@@ -897,12 +1154,16 @@
 	{
 	    DECLARE_MUTEX_LOCKED(sem);
 	    SCpnt->request.sem = &sem;
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	    spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	    scsi_do_cmd (SCpnt,
 			 (void *) cmd, (void *) buffer,
 			 512, sr_init_done,  SR_TIMEOUT,
 			 MAX_RETRIES);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	    spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	    down(&sem);
 	}
 
@@ -918,16 +1179,16 @@
 
     if (the_result) {
 	scsi_CDs[i].capacity = 0x1fffff;
-	scsi_CDs[i].sector_size = 2048;  /* A guess, just in case */
+	sector_size = 2048;  /* A guess, just in case */
 	scsi_CDs[i].needs_sector_size = 1;
     } else {
 	scsi_CDs[i].capacity = 1 + ((buffer[0] << 24) |
 				    (buffer[1] << 16) |
 				    (buffer[2] << 8) |
 				    buffer[3]);
-	scsi_CDs[i].sector_size = (buffer[4] << 24) |
+	sector_size = (buffer[4] << 24) |
 	    (buffer[5] << 16) | (buffer[6] << 8) | buffer[7];
-	switch (scsi_CDs[i].sector_size) {
+	switch (sector_size) {
 		/*
 		 * HP 4020i CD-Recorder reports 2340 byte sectors
 		 * Philips CD-Writers report 2352 byte sectors
@@ -935,7 +1196,7 @@
 		 * Use 2k sectors for them..
 		 */
 		case 0: case 2340: case 2352:
-			scsi_CDs[i].sector_size = 2048;
+			sector_size = 2048;
 			/* fall through */
 		case 2048:
 			scsi_CDs[i].capacity *= 4;
@@ -944,11 +1205,17 @@
 			break;
 		default:
 			printk ("sr%d: unsupported sector size %d.\n",
-				i, scsi_CDs[i].sector_size);
+				i, sector_size);
 			scsi_CDs[i].capacity = 0;
 			scsi_CDs[i].needs_sector_size = 1;
 	}
 
+#ifdef CONFIG_SCSI_NEW_QUEUES
+        scsi_CDs[i].device->sector_size = sector_size;
+#else
+        scsi_CDs[i].sector_size = sector_size;
+#endif
+
         /*
          * Add this so that we have the ability to correctly gauge
          * what the device is capable of.
@@ -1051,7 +1318,13 @@
     int i;
     char name[6];
 
-    blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    blk_dev[MAJOR_NR].queue = sr_find_queue;
+#else
+    blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), DEVICE_REQUEST);
+    blk_queue_headactive(BLK_DEFAULT_QUEUE(MAJOR_NR), 0);
+#endif
+
     blk_size[MAJOR_NR] = sr_sizes;
 
     for (i = 0; i < sr_template.nr_dev; ++i)
@@ -1060,7 +1333,11 @@
 	 * with loadable modules. */
 	if (scsi_CDs[i].capacity) continue;
 	scsi_CDs[i].capacity = 0x1fffff;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+	scsi_CDs[i].device->sector_size = 2048;  /* A guess, just in case */
+#else
 	scsi_CDs[i].sector_size = 2048;  /* A guess, just in case */
+#endif
 	scsi_CDs[i].needs_sector_size = 1;
 	scsi_CDs[i].device->changed = 1; /* force recheck CD type */
 #if 0
@@ -1069,8 +1346,14 @@
 	printk("Scd sectorsize = %d bytes.\n", scsi_CDs[i].sector_size);
 #endif
 	scsi_CDs[i].use = 1;
+
+#ifdef CONFIG_SCSI_NEW_QUEUES
+	scsi_CDs[i].device->ten = 1;
+	scsi_CDs[i].device->remap = 1;
+#else
 	scsi_CDs[i].ten = 1;
 	scsi_CDs[i].remap = 1;
+#endif
       	scsi_CDs[i].readcd_known = 0;
       	scsi_CDs[i].readcd_cdda  = 0;
 	sr_sizes[i] = scsi_CDs[i].capacity >> (BLOCK_SIZE_BITS - 9);
@@ -1159,7 +1442,7 @@
     }
 
     blksize_size[MAJOR_NR] = NULL;
-    blk_dev[MAJOR_NR].request_fn = NULL;
+    blk_cleanup_queue(BLK_DEFAULT_QUEUE(MAJOR_NR));
     blk_size[MAJOR_NR] = NULL;
     read_ahead[MAJOR_NR] = 0;
 
diff -u -r linux.clean/drivers/scsi/sr.h linux.new2/drivers/scsi/sr.h
--- linux.clean/drivers/scsi/sr.h	Mon Sep  6 09:15:13 1999
+++ linux.new2/drivers/scsi/sr.h	Mon Sep  6 09:14:33 1999
@@ -9,7 +9,7 @@
  *
  *	<drew@colorado.edu>
  *
- *       Modified by Eric Youngdale eric@aib.com to
+ *       Modified by Eric Youngdale eric@andante.org to
  *       add scatter-gather, multiple outstanding request, and other
  *       enhancements.
  */
@@ -22,15 +22,20 @@
 typedef struct
 	{
 	unsigned 	capacity;		/* size in blocks 			*/
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	unsigned 	sector_size;		/* size in bytes 			*/
+#endif
+
 	Scsi_Device  	*device;
         unsigned int    vendor;                 /* vendor code, see sr_vendor.c         */
 	unsigned long   ms_offset;              /* for reading multisession-CD's        */
 	unsigned char	sector_bit_size;	/* sector size = 2^sector_bit_size	*/
 	unsigned char	sector_bit_shift;	/* sectors/FS block = 2^sector_bit_shift*/
 	unsigned 	needs_sector_size:1;   	/* needs to get sector size */
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	unsigned 	ten:1;			/* support ten byte commands		*/
 	unsigned 	remap:1;		/* support remapping			*/
+#endif
 	unsigned 	use:1;			/* is this device still supportable	*/
         unsigned	xa_flag:1;              /* CD has XA sectors ? */
 	unsigned 	readcd_known:1;		/* drive supports READ_CD (0xbe) */
diff -u -r linux.clean/drivers/scsi/sr_ioctl.c linux.new2/drivers/scsi/sr_ioctl.c
--- linux.clean/drivers/scsi/sr_ioctl.c	Sun May 16 02:43:04 1999
+++ linux.new2/drivers/scsi/sr_ioctl.c	Wed Jul 28 19:22:40 1999
@@ -56,10 +56,18 @@
     int result, err = 0, retries = 0;
     unsigned long flags;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
     SDev  = scsi_CDs[target].device;
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    SCpnt = scsi_allocate_device(scsi_CDs[target].device, 1);
+#else
     SCpnt = scsi_allocate_device(NULL, scsi_CDs[target].device, 1);
+#endif
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 
 retry:
     if( !scsi_block_when_processing_errors(SDev) )
@@ -67,11 +75,15 @@
     {
 	DECLARE_MUTEX_LOCKED(sem);
 	SCpnt->request.sem = &sem;
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_do_cmd(SCpnt,
 		    (void *) sr_cmd, buffer, buflength, sr_ioctl_done, 
 		    IOCTL_TIMEOUT, IOCTL_RETRIES);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 	spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	down(&sem);
         SCpnt->request.sem = NULL;
     }
@@ -97,14 +109,18 @@
                     printk(KERN_INFO "sr%d: CDROM not ready yet.\n", target);
 		if (retries++ < 10) {
 		    /* sleep 2 sec and try again */
+#ifndef CONFIG_SCSI_NEW_QUEUES
 		    /*
 		     * The spinlock is silly - we should really lock more of this
 		     * function, but the minimal locking required to not lock up
 		     * is around this - scsi_sleep() assumes we hold the spinlock.
 		     */
 		    spin_lock_irqsave(&io_request_lock, flags);
+#endif
 		    scsi_sleep(2*HZ);
+#ifndef CONFIG_SCSI_NEW_QUEUES
 		    spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
                     goto retry;
 		} else {
 		    /* 20 secs are enough? */
@@ -242,7 +258,9 @@
         u_char  sr_cmd[10];
 	char * buffer;
         int result;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
         	
 	sr_cmd[0] = SCMD_READ_SUBCHANNEL;
 	sr_cmd[1] = ((scsi_CDs[MINOR(cdi->dev)].device->lun) << 5);
@@ -254,9 +272,13 @@
 	sr_cmd[8] = 24;
 	sr_cmd[9] = 0;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buffer = (unsigned char*) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!buffer) return -ENOMEM;
 	
 	result = sr_do_ioctl(MINOR(cdi->dev), sr_cmd, buffer, 24, 0);
@@ -264,9 +286,13 @@
 	memcpy (mcn->medium_catalog_number, buffer + 9, 13);
         mcn->medium_catalog_number[13] = 0;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	
 	return result;
 }
@@ -396,7 +422,9 @@
     {
 	struct cdrom_tochdr* tochdr = (struct cdrom_tochdr*)arg;
 	char * buffer;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 	
 	sr_cmd[0] = SCMD_READ_TOC;
 	sr_cmd[1] = ((scsi_CDs[target].device->lun) << 5);
@@ -406,9 +434,13 @@
 	sr_cmd[8] = 12;             /* LSB of length */
 	sr_cmd[9] = 0;
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buffer = (unsigned char *) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!buffer) return -ENOMEM;
 	
 	result = sr_do_ioctl(target, sr_cmd, buffer, 12, 1);
@@ -416,9 +448,13 @@
 	tochdr->cdth_trk0 = buffer[2];
 	tochdr->cdth_trk1 = buffer[3];
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
         break;
     }
 	
@@ -426,7 +462,9 @@
     {
 	struct cdrom_tocentry* tocentry = (struct cdrom_tocentry*)arg;
 	unsigned char * buffer;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 	
 	sr_cmd[0] = SCMD_READ_TOC;
 	sr_cmd[1] = ((scsi_CDs[target].device->lun) << 5) |
@@ -437,9 +475,13 @@
 	sr_cmd[8] = 12;            /* LSB of length */
 	sr_cmd[9] = 0;
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buffer = (unsigned char *) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!buffer) return -ENOMEM;
 	
 	result = sr_do_ioctl (target, sr_cmd, buffer, 12, 0);
@@ -455,9 +497,13 @@
 	    tocentry->cdte_addr.lba = (((((buffer[8] << 8) + buffer[9]) << 8)
                                        + buffer[10]) << 8) + buffer[11];
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
         break;
     }
 	
@@ -483,7 +529,9 @@
     {
 	char * buffer, * mask;
 	struct cdrom_volctrl* volctrl = (struct cdrom_volctrl*)arg;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 	
 	/* First we get the current params so we can just twiddle the volume */
 	
@@ -494,16 +542,24 @@
 	sr_cmd[4] = 28;
 	sr_cmd[5] = 0;
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buffer = (unsigned char *) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!buffer) return -ENOMEM;
 	
 	if ((result = sr_do_ioctl (target, sr_cmd, buffer, 28, 0))) {
 	    printk ("Hosed while obtaining audio mode page\n");
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	    scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
             break;
 	}
 	
@@ -514,23 +570,35 @@
 	sr_cmd[4] = 28;
 	sr_cmd[5] = 0;
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	mask = (unsigned char *) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!mask) {
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	    scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	    result = -ENOMEM;
             break;
 	};
 
 	if ((result = sr_do_ioctl (target, sr_cmd, mask, 28, 0))) {
 	    printk ("Hosed while obtaining mask for audio mode page\n");
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	    scsi_free(buffer, 512);
 	    scsi_free(mask, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	    break;
 	}
 	
@@ -549,10 +617,14 @@
 	sr_cmd[5] = 0;
 	
 	result = sr_do_ioctl (target, sr_cmd, buffer, 28, 0);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(buffer, 512);
 	scsi_free(mask, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
         break;
     }
 	
@@ -560,7 +632,9 @@
     {
 	char * buffer;
 	struct cdrom_volctrl* volctrl = (struct cdrom_volctrl*)arg;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 	
 	/* Get the current params */
 	
@@ -571,16 +645,24 @@
 	sr_cmd[4] = 28;
 	sr_cmd[5] = 0;
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buffer = (unsigned char *) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!buffer) return -ENOMEM;
 	
 	if ((result = sr_do_ioctl (target, sr_cmd, buffer, 28, 0))) {
 	    printk ("(CDROMVOLREAD) Hosed while obtaining audio mode page\n");
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	    scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
             spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
             break;
 	}
 
@@ -589,9 +671,13 @@
 	volctrl->channel2 = buffer[25];
 	volctrl->channel3 = buffer[27];
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
         break;
     }
 	
@@ -599,7 +685,9 @@
     {
 	struct cdrom_subchnl* subchnl = (struct cdrom_subchnl*)arg;
 	char * buffer;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 	
 	sr_cmd[0] = SCMD_READ_SUBCHANNEL;
 	sr_cmd[1] = ((scsi_CDs[target].device->lun) << 5) | 0x02;    /* MSF format */
@@ -611,9 +699,13 @@
 	sr_cmd[8] = 16;
 	sr_cmd[9] = 0;
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	buffer = (unsigned char *) scsi_malloc(512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if(!buffer) return -ENOMEM;
 	
 	result = sr_do_ioctl(target, sr_cmd, buffer, 16, 0);
@@ -631,9 +723,13 @@
 	subchnl->cdsc_absaddr.msf.second = buffer[10];
 	subchnl->cdsc_absaddr.msf.frame = buffer[11];
 	
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(buffer, 512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
         break;
     }
     default:
@@ -710,9 +806,15 @@
     }
 
     /* ... if this fails, we switch the blocksize using MODE SELECT */
+#ifdef CONFIG_SCSI_NEW_QUEUES
+    if (blksize != scsi_CDs[minor].device->sector_size)
+#else
     if (blksize != scsi_CDs[minor].sector_size)
+#endif
+    {
         if (0 != (rc = sr_set_blocklength(minor, blksize)))
             return rc;
+    }
 
 #ifdef DEBUG
     printk("sr%d: sr_read_sector lba=%d blksize=%d\n",minor,lba,blksize);
@@ -741,14 +843,20 @@
 {
     unsigned char *raw_sector;
     int is_xa;
+#ifndef CONFIG_SCSI_NEW_QUEUES
     unsigned long flags;
+#endif
     
     if (!xa_test)
         return 0;
    
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
     raw_sector = (unsigned char *) scsi_malloc(2048+512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
     if (!raw_sector) return -ENOMEM;
     if (0 == sr_read_sector(minor,scsi_CDs[minor].ms_offset+16,
                             CD_FRAMESIZE_RAW1,raw_sector)) {
@@ -757,9 +865,13 @@
         /* read a raw sector failed for some reason. */
         is_xa = -1;
     }
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_lock_irqsave(&io_request_lock, flags);
+#endif
     scsi_free(raw_sector, 2048+512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
     spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 #ifdef DEBUG
     printk("sr%d: sr_is_xa: %d\n",minor,is_xa);
 #endif
@@ -782,7 +894,9 @@
         struct cdrom_msf   msf;
         int                lba, rc;
 	int                blocksize = 2048;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 
         switch (cmd) {
         case CDROMREADMODE2: blocksize = CD_FRAMESIZE_RAW0; break; /* 2336 */
@@ -791,9 +905,13 @@
 
 	if (copy_from_user(&msf,(void*)arg,sizeof(msf)))
 		return -EFAULT;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
         raw = scsi_malloc(2048+512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if (!(raw))
                 return -ENOMEM;
 
@@ -807,9 +925,13 @@
 		if (copy_to_user((void*)arg, raw, blocksize))
 			rc = -EFAULT;
 
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(raw,2048+512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	return rc;
     }
     case CDROMREADAUDIO:
@@ -817,7 +939,9 @@
 	unsigned char      *raw;
         int                lba, rc=0;
         struct cdrom_read_audio ra;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         unsigned long flags;
+#endif
 
         if (!scsi_CDs[target].readcd_known || !scsi_CDs[target].readcd_cdda)
             return -EINVAL;  /* -EDRIVE_DOES_NOT_SUPPORT_THIS ? */
@@ -833,9 +957,13 @@
 
         if (lba < 0 || lba >= scsi_CDs[target].capacity)
             return -EINVAL;
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
         raw = scsi_malloc(2048+512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
 	if (!(raw))
             return -ENOMEM;
 
@@ -851,9 +979,13 @@
             ra.nframes -= 1;
             lba++;
         }
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_lock_irqsave(&io_request_lock, flags);
+#endif
 	scsi_free(raw,2048+512);
+#ifndef CONFIG_SCSI_NEW_QUEUES
         spin_unlock_irqrestore(&io_request_lock, flags);
+#endif
         return rc;
     }
 
diff -u -r linux.clean/drivers/scsi/sr_vendor.c linux.new2/drivers/scsi/sr_vendor.c
--- linux.clean/drivers/scsi/sr_vendor.c	Mon May 10 16:01:21 1999
+++ linux.new2/drivers/scsi/sr_vendor.c	Wed Jul 28 19:22:40 1999
@@ -134,7 +134,13 @@
 	modesel->block_length_med  = (blocklength >> 8 ) & 0xff;
 	modesel->block_length_lo   =  blocklength        & 0xff;
 	if (0 == (rc = sr_do_ioctl(minor, cmd, buffer, sizeof(*modesel), 0)))
+	{
+#ifdef CONFIG_SCSI_NEW_QUEUES
+		scsi_CDs[minor].device->sector_size = blocklength;
+#else
 		scsi_CDs[minor].sector_size = blocklength;
+#endif
+	}
 #ifdef DEBUG
 	else
 		printk("sr%d: switching blocklength to %d bytes failed\n",
@@ -287,8 +293,14 @@
 	if (CDS_AUDIO != sr_disk_status(cdi) && 1 == sr_is_xa(minor))
 		scsi_CDs[minor].xa_flag = 1;
 	
+#ifdef CONFIG_SCSI_NEW_QUEUES
+	if (2048 != scsi_CDs[minor].device->sector_size)
+#else
 	if (2048 != scsi_CDs[minor].sector_size)
+#endif
+	{
 		sr_set_blocklength(minor,2048);
+	}
 	if (no_multi)
 		cdi->mask |= CDC_MULTI_SESSION;
 
